module InlineTester

  module Assertions

    $__stack_ = 2

    public
    def assert boolean, message=nil
      unless boolean
        # MESSAGE::: Assertion did not pass.
        $stdout.print(message || 
          "Expected a truthy value, but instead got #{boolean}")
        stack_trace_print
      else

      end
    end

    def refute boolean, message=nil
      if boolean
        # MESSAGE::: Refution did not pass.
        $stdout.print(message || 
          "Expected a falsy value, but instead got #{boolean}")
        stack_trace_print
      else

      end
    end

    def assert_something_raised message=nil, &block
      begin
        yield
        # Message::: Nothing raised.
        $stdout.print(message || 
          "Expected #{block} to raise an Exception, but it did not.")
        stack_trace_print
      rescue => e
        
      end
    end

    def assert_matches string, pattern, message=nil
      $__stack_+=1
      assert(string =~ pattern, message || 
        "Expected #{string} to match #{pattern}, but it did not.")
      $__stack_-=1
    end

    def skip message=nil, &block
      $stdout.print message || "Skipped assertion."
      if block_given?
        yield
      end
    end

    def todo message=nil
      $stdout.print message || "TODO!"
      stack_trace_print
    end

    private
    def stack_trace_print
      puts " from:"
      # Print stack trace from _stack_ with at most 3 more deep 
      caller_locations($__stack_, 3).map do |call|
        $stdout.puts "===> #{call.to_s}"
      end
    end

  end

end